/*
 DSPAM
 COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "libdspam_objects.h"
#include "buffer.h"

#ifdef HAVE_CONFIG_H
#include <auto-config.h>
#endif

#ifndef _DSPAM_H
#  define _DSPAM_H

#ifndef MLOCAL
#ifdef FREEBSD
#       define  MLOCAL          "/usr/libexec/mail.local"
#endif

#ifdef LINUX
#       define  MLOCAL          "/usr/bin/procmail"
#endif

#ifdef SOLARIS2
#       define  MLOCAL          "/usr/bin/mail"
#endif
#endif

/* Signature identifiers; don't modify unless you understand the 
   subtle consequences */

#define         SIGNATURE_BEGIN		"!DSPAM:"
#define         SIGNATURE_END		"!"
#define         LOOSE_SIGNATURE_BEGIN	"DSPAM:"
#define         SIGNATURE_DELIMITER	":"

/* Public agent functions */
int deliver_message (const char *message, const char *mailer_args,
                     const char *username, int mode);
int process_message (char *group, size_t size, buffer * message,
                     const char *username, int mode, int flags,
                     const char *mailer_args);
int write_web_stats (const char *username, struct _ds_spam_totals *totals);
int quarantine_message (const char *message, const char *username);
int quarantine_unlock (const char *username);
int quarantine_lock (const char *username);
int inoculate_user (const char *username, struct _ds_spam_signature *SIG,
                    const char *message);
int user_classify (const char *username, struct _ds_spam_signature *SIG,
                   const char *message);
int send_notice(const char *filename, const char *mailer_args,
                const char *username, int mode);


/* DO NOT MODIFY BELOW THIS LINE */

#ifndef MIN
#   define MAX(a,b)  ((a)>(b)?(a):(b))
#   define MIN(a,b)  ((a)<(b)?(a):(b))
#endif /* !MIN */

#define IAT_NONE	0x00
#define IAT_MD5		0x01
#define IAT_SIGNED	0x02
#define IAT_UNKNOWN	0xFF

/* DSPAM Agent Flags (not to be confused with DSPAM API flags) */
#define DAF_CORPUS	0x01
#define DAF_INOCULATE	0x02
#define DAF_STDOUT	0x04
#define DAF_NEURAL	0x08
#define DAF_GLOBAL	0x10

#endif /* _DSPAM_H */
